/*
 * Author:          Patrick-Christopher Mattulat
 * Co-Author:       Claude Sonnet 4.6 (LLM)
 * Company:         Lynar Studios
 * E-Mail:          webmaster@lynarstudios.com
 * Created:         2021-05-27
 * Changed:         2026-06-23
 *
 * */

#include <gtest/gtest.h>
#include <ls-std/ls-std-core.hpp>
#include <string>

using ls::standard::core::EventNotHandledException;
using std::string;
using testing::Test;

namespace
{
  class EventNotHandledExceptionTest : public Test
  {
    public:

      EventNotHandledExceptionTest() = default;
      ~EventNotHandledExceptionTest() override = default;
  };

  TEST_F(EventNotHandledExceptionTest, constructor)
  {
    EXPECT_THROW(
        {
          try
          {
            throw EventNotHandledException{};
          }
          catch (const EventNotHandledException &_exception)
          {
            const string actual = _exception.what();
            const string expected = _exception.getName() + " thrown - event was not handled - nothing happened!";

            EXPECT_STREQ(expected.c_str(), actual.c_str());
            throw;
          }
        },
        EventNotHandledException);
  }

  TEST_F(EventNotHandledExceptionTest, constructor_dedicated_message)
  {
    EXPECT_THROW(
        {
          try
          {
            throw EventNotHandledException{"id: OPEN_DOOR"};
          }
          catch (const EventNotHandledException &_exception)
          {
            const string actual = _exception.what();
            const string expected = _exception.getName() + " thrown - id: OPEN_DOOR";

            EXPECT_STREQ(expected.c_str(), actual.c_str());
            throw;
          }
        },
        EventNotHandledException);
  }

  TEST_F(EventNotHandledExceptionTest, getName)
  {
    ASSERT_STREQ("EventNotHandledException", EventNotHandledException{}.getName().c_str());
  }
}
